; Author:      Roy Klein Gebbinck (www.b-k-g.nl)
; Created for: https://forum.bricsys.com/discussion/31912/pan-xclipped-xrefs?

; 20171219: Added DXF code check.
;           Release Notes Version 17.2.07:
;           AcDbSpatialFilter DXF code for 'inverted' flag was wrong, now uses 290 instead of 280 (SR75127).
; 20170331
(defun XclipInvert (enm / dict dxf spfl)
  (if
    (and
      (setq dict (vle-entget 360 enm))
      (setq dict (vle-dictobjname dict "ACAD_FILTER"))
      (setq spfl (vle-dictobjname dict "SPATIAL"))     ; "SPATIAL_FILTER" entity.
    )
    (progn
      (setq dxf (if (vle-entget 290 spfl) 290 280)) ; Correct group code is 290 (since V17.2.07).
      (vle-entmod dxf spfl (boole 6 (vle-entget dxf spfl) 1))
      (entupd enm)
    )
  )
)

(defun c:XclipInvert ( / doc ss)
  (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-endundomark doc)
  (vla-startundomark doc)
  (if (setq ss (ssget '((0 . "INSERT")(102 . "{ACAD_XDICTIONARY"))))
    (foreach enm (vle-selectionset->list ss)
      (XclipInvert enm)
    )
  )
  (vla-endundomark doc)
  (princ)
)
